import cv2
import re
import csv
import pyrebase
import time
from datetime import date, datetime

firebaseConfig = {
  "apiKey": "AIzaSyD6xLtIq25e1we1jyvUtGZF7V6bDJeeVmo",
  "authDomain": "depozit-agricol.firebaseapp.com",
  "projectId": "depozit-agricol",
  "databaseURL":"https://depozit-agricol-default-rtdb.europe-west1.firebasedatabase.app/",
  "storageBucket": "depozit-agricol.appspot.com",
  "messagingSenderId": "709977840888",
  "appId":"1:709977840888:web:fb731e4fbd05fe5a8a2f0d",
  "measurementId": "G-JHVJTJVSBP"
};


firebase=pyrebase.initialize_app(firebaseConfig)
db=firebase.database()

cap = cv2.VideoCapture(0)
detector = cv2.QRCodeDetector()

today = date.today()
date = today.strftime("%d-%b-%Y")



print("Reading QR code using Raspberry Pi camera")
print()

while True:
        _, img = cap.read()
        data, bbox, _ = detector.detectAndDecode(img)
        now = datetime.now()
        timeRN = now.strftime("%H:%M:%S")
        if bbox is not None:
            for i in range(len(bbox)):
                cv2.line(img, tuple(bbox[i][0]), tuple(bbox[(i+1) % len(bbox)][0]), color=(255,
                         0, 0), thickness=2)
            
            cv2.putText(img, data, (int(bbox[0][0][0]), int(bbox[0][0][1]) - 10), cv2.FONT_HERSHEY_SIMPLEX,
                    1, (255, 250, 120), 2)
            
            if data:
                                
                data = data.split(",")
                print("ID: " + data[0])
                print("Tip: " + data[1])
                print("Cantitate: " + data[2])
                print("Pret/Kg: " + data[3])
                print("Tara provenienta: " + data[4])                             
                print("Data scanarii: " + date)
                print("Ora scanarii: "+ timeRN)
                print()
               
                
                id_var= data[0]
                tip=data[1]
                cantitate=data[2]
                pret=data[3] 
                tara=data[4]
                
                
                data_db={
                    "ID":id_var,
                    "Tip":tip,
                    "Cantitate":cantitate,
                    "Pret":pret,
                    "Tara":tara,
                    "Data_scanarii":date,
                    "Ora_scanarii":timeRN,
                  }
            
                userScanned = False
                with open('Database.csv') as csvfile:
                    reader = csv.DictReader(csvfile)
                    for row in reader:
                        if row["ID"] == data[0]:                        
                            userScanned = True
                    
                if userScanned == False:
                    with open('Database.csv', 'a') as csvfile:
                        fieldNames = ['ID', 'TIP', 'CANTITATE', 'PRET', 'TARA']
                        writer = csv.DictWriter(csvfile, fieldnames=fieldNames)
                        writer.writerow({'ID': data[0], 'TIP': data[1], 'CANTITATE': data[2], 'PRET': data[3], 'TARA':data[4]})
                        
                   
                    db.child("ultima_scanare").set(data_db)
                    db.child("inventar_depozit").push(data_db)
               
                   
                
                   
                 
                    
                    
            cv2.imshow("code detector", img)
            
    
        else:
            cap.read()       
            cv2.destroyAllWindows()
           
    
        if cv2.waitKey(500) == ord("q"):   #display window for 'x' miliseconds
            break

cap.release()
cv2.destroyAllWindows()
